//
//  Althea.cpp  --  Althea class functions
//  -- created  4/16/00   updated 4/19/00
////////////////////////////////////////////////

#include <list>
#include <iostream.h>
#include "Althea.h"

Althea gAlthea;

int Althea::get_Num_Servers()
{
    return( server_list.size() );
}

char Althea::get_Verbose()
{
    return( verbose );
}

Server * Althea::get_Server( const string &name )
{
    list<Server>::iterator it;
    it = server_list.begin();
    while( it != server_list.end() && (*it).get_Server_Name() != name )
        it++;

    if( (*it).get_Server_Name() == name )
        return( &(*it) );

    else
        return( NULL );
}

Server * Althea::get_Server( int index )
{
    int count = 1;
    list<Server>::iterator it;
    it = server_list.begin();
    
    while( it != server_list.end() && count < index )
    {
        count++;
        it++;
    }
    
    if( count == index )
        return( &(*it) );

    else
        return( NULL );   
}


GtkWidget *Althea::get_folder_list()
{
    return( folder_list );
}

GtkWidget *Althea::get_message_list()
{
    return( message_list );
}

GtkWidget *Althea::get_message_text()
{
    return( message_text );
}

GtkWidget *Althea::get_main_window()
{
    return( main_window );
}

Configuration Althea::get_Configuration()
{
    return( config );
}

Server * Althea::get_Current_Server()
{
    return( current_server );
}

Folder * Althea::get_Current_Folder()
{
    return( current_folder );
}


Message * Althea::get_Current_Message()
{
    return( current_message );
}

bool Althea::is_Current_Server()
{
    return( current_server != NULL );
}

bool Althea::is_Current_Folder()
{
    return( current_folder != NULL );
}

bool Althea::is_Current_Message()
{
    return( current_message != NULL );
}





void Althea::set_folder_list( GtkWidget *flist )
{
    folder_list = flist;
}

void Althea::set_message_list( GtkWidget *mlist )
{
    message_list = mlist;
}

void Althea::set_message_text( GtkWidget *mtext )
{
    message_text = mtext;
}

void Althea::set_main_window( GtkWidget *mwindow )
{
    main_window = mwindow;
}

void Althea::set_Current_Server( Server *S )
{
    current_server = S;
}

void Althea::set_Current_Folder( Folder *F )
{
    current_folder = F;
}


void Althea::set_Current_Message( Message *M )
{
    current_message = M;
}


void Althea::set_Verbose( char v )
{
    verbose = v;
}




void Althea::add_Server( const Server &S )
{
    server_list.push_back( S );
}

void Althea::add_Filter( const Filter &F )
{
    filter_list.push_back( F );
}



void Althea::delete_Server( const string &name )
{
    list<Server>::iterator it;

    it = server_list.begin();
    while( it != server_list.end() && (*it).get_Server_Name() != name )
        it++;

    if( (*it).get_Server_Name() == name )
        server_list.erase( it );
}

void Althea::delete_Filter( const string &name )
{
    list<Filter>::iterator it;

    it = filter_list.begin();
    while( it != filter_list.end() && (*it).filter_string != name )
        it++;

    if( (*it).filter_string == name )
        filter_list.erase( it );
}

// Debugging purposes only

void Althea::display()
{
    list<Server>::iterator it;
    it = server_list.begin();
    while( it != server_list.end() )
    {
        (*it).display();
        //cout << "Server: " << (*it).get_Server_Name() << endl;
        it++;
    }
}

void Althea::display_filters()
{
list<Filter>::iterator it;
    it = filter_list.begin();
    while( it != filter_list.end() )
    {
      cout << "Filter String:" << (*it).filter_string << endl;
        it++;
    }

}


