//
//  SendMail.cpp  --  Wrapper function to send mail.  Now uses smtp.
//  -- created 4/11/00  updated 4/11/00
/////////////////////////////////////////

#include "SendMail.h"

extern Althea gAlthea;

// the maximum length for a line
//  -- we might want to change this so that it is
//  determined by the body type.  ie, 1000 for some
//  encoded thing, but for hujman readable make it
//  76.
const int MAX_LINE_LENGTH = 70;

void getProperDate(string &date)  {
   // given string of the form:
   // Thu May 18 16:38:50 2000 (CDT)\n
   // we want:
   // Thu, 18 May 2000 14:43:43 -0500
   string dayNum;
   string year;


   dayNum = date.substr(8,3);
   year = date.substr(20,5);
   date.erase(20,5);
   date.erase(8,3);
   year.replace(4,1," ");
   if (gAlthea.get_Verbose())
     cout << date << endl;
   // now looks like:
   // Thu May 16:38:50 (CDT)
   date.insert(8,year);
   date.insert(4,dayNum);
   date.insert(3,",");
}

int SendMail(Message *M)  {

   /*********************************************
    * our variables				*
    *********************************************/

   string date;
   string bodyData;
   string tmp;
   int bodyCounter;
   int lineLength;
   int bodyLengthCounter;
   int bodyPartsCounter;
   int prevSpacePos=0;
   time_t tme;

   // hard code our relevant variables until we get
   // this working in a class
   //
   // so how is this stuff going to be passed in?
   // will it be global? will I have to pass the
   // nameof the server and whatnot to SMTPSend?
   string to = M->get_To_Address();
   string from = M->get_From_Address();
   string subject = M->get_Subject() + "\r\n";
   string CC = M->get_CC_Address();
   string otherHeaders = "";
   string SMTPServer = M->get_Server_Ptr()->get_SMTP_Server_Name();
   //string SMTPServer = "smtp.carleton.edu";
   string bodyParts[2];

   bodyParts[0] = M->get_Body_Text();

   /*********************************************
    * check to make sure our message is a	*
    * legitimate RFC 821/822 message		*
    *********************************************/

   // make sure we have all the required headers
   // checks occuring in order of severity, from 
   // most to least

   if (to == "")  {
      // no valid recipient.  
      // not a recoverable error

      // "To field unspecified"
      return(1);
   }

   if (from == "")  {
      // sender not specified.

      // "Sender not specified"
      return(2);
   }
   // make sure lines do not exceed MAX_LINE_LENGTH characters
   // and as long as we are looking at everything,
   // make sure it is all valid US-ASCI.
   //
   // i am not sure whether this is the most efficient method
   // of performing this search ornot.  if there is a better 
   // way, most likely by using substring searches, it can
   // be easily added here without hurting anything else.
   for (bodyPartsCounter=0; 
        bodyPartsCounter < (int)bodyParts[bodyPartsCounter].length(); 
        bodyPartsCounter++)  {
      lineLength = 0;
      for (bodyLengthCounter=0; bodyParts[bodyPartsCounter][bodyLengthCounter];
                      bodyLengthCounter++)  {
         if (bodyParts[bodyPartsCounter][bodyLengthCounter]=='\n')  {
            // here is a newline so let's reset our counter
            lineLength = 0;
	    prevSpacePos = bodyLengthCounter;
         }
	 // ok.  think of all the possible word delimeters.
         else if (bodyParts[bodyPartsCounter][bodyLengthCounter]==' ')  {
            // we have a break between words.
	    // remember this position so our line breaks are 
	    // are quite so random
	    prevSpacePos = bodyLengthCounter;
	 }
         
	 if ((lineLength>MAX_LINE_LENGTH) && 
	     (bodyParts[bodyPartsCounter][bodyLengthCounter]!=' '))  {
            // insert a new line for 'em
	    // and remove any leading spaces on the newline
            //bodyParts[bodyPartsCounter].insert(prevSpacePos,"\r");
	    // ^--- for some reason having this in there, in pine at
	    //      least makes it do double lines.  dunno why.
	    //      would be nice to see if we have this same affect
	    //      in other mail clients as well.
            bodyParts[bodyPartsCounter].insert(prevSpacePos,"\n");
            lineLength = 0;
	    prevSpacePos = bodyLengthCounter;
         }
         else  {
            lineLength++;
         }
      }
   }
   /*********************************************
    * lets get all of our stuff attached	*
    * to the body all nice like			*
    *********************************************/
   // get our date header taken care of.
   // this is a lot uglier then is should be,
   // but I don't know how to do it otherwise.
   // there has to be some command that will 
   // get both the date as well as the time zone,
   // but the stuff from ctime and time.h have
   // the timezone seperated.
   // get the current time, local time.
   time(&tme);
   localtime(&tme);
   tmp = ctime(&tme);

   // the string comes with a \n, lets remove that.
   //tmp[tmp.length()-1] = ' ';
   getProperDate(tmp);
   if (gAlthea.get_Verbose())
     cout << tmp;

   // concatenate all of our date sutff together
   date = "Date: " + tmp + "(" + tzname[1] + ")";
   if (gAlthea.get_Verbose())
     cout << date << endl;

   // add headers
   bodyData = date + "\r\n" + "To: " + to + "\r\n";
   if (CC == "") 
	bodyData += otherHeaders + "Subject: " + subject + "\r\n";
   else
	bodyData += "CC: " + CC + "\r\n" + otherHeaders + "Subject: " + subject + "\r\n";

   // add body
   //for (bodyCounter = 0; bodyCounter<bodyParts.length(); bodyCounter++)  {
   for (bodyCounter = 0; bodyCounter<1; bodyCounter++)  {
      bodyData += bodyParts[bodyCounter];
   }

   // add EOF
   bodyData += "\r\n.\r\n";

   /*********************************************
    * send the message				*
    *********************************************/

   int port = 25; // default port number
   string errcodestr;
   int errcode;
   // send via SMTP
   // and return whatever error code SMTPSend
   // may have

   //  Note right now, cc and bcc are not implemented!!

   errcode = SMTPSend(SMTPServer,port,to,CC,"",from,bodyData,errcodestr);
   if (errcode == SUCCESS)
     if (gAlthea.get_Verbose())
       cout << "message sent" << endl;

   // Now get rid of "Date: " to store the value back in Message class
   date = date.substr(6);
   M->set_Date(date);
   return(errcode);
}
