//
//  callbacks.c  --  gtk functions to make callbacks
//  -- created  5/23/00 updated 5/23/00
//////////////////////////////////////////////

#include "callbacks.h"

extern Althea gAlthea;

/*
void                                    
on_password_window_okay                 (GtkObject       *object,
                                        gpointer        user_data) {

  password_widgets *temp = (password_widgets *) user_data;
  Server *the_server = temp->the_server;
  GtkWidget *password_text = temp->password_text;
  int ret_val, j;
  Folder *F;
  GtkWidget *folder

  string password = gtk_editable_get_chars( GTK_EDITABLE (password_text), 0, -1 );
  the_server->set_Password( password );
  //if( the_server->login() != SUCCESS )
  //  error( "Could not log in to server " + the_server->get_Server_Name() );

  if( the_server->login() == SUCCESS ) {
    ret_val = the_server->get_Folder_List_From_Server();
    if( ret_val == SUCCESS ) {
      for( j = 1; j <= the_server->get_Num_Folders(); j++ ) {
        F = the_server->get_Folder( j );
        folder = create_folder_in_server( F, server );
      }
    } else
      error( "Could not get mailbox listing from server " + the_server->get_Server_Name() );
  } else
    error( "Could not log in to server " + the_server->get_Server_Name() );
}
*/

void
on_printButton_clicked                       (GtkButton       *button,
                                              gpointer         user_data)
{
   string sTmpFile = "/tmp/printMail.althea";
   string sCommand = gtk_editable_get_chars( GTK_EDITABLE( user_data ), 0, -1 );

   Message *M = gAlthea.get_Current_Message();

   if ( M == NULL )   {
      error ( "Select a message to print.\n" );
   }
   else   {

      string sLetter = "From: " + M->get_From_Address() + "\n" +
                       "To: " + M->get_To_Address() + "\n" +
                       "Date: " + M->get_Date() + "\n" +
                       "Subject: " + M->get_Subject() + "\n\n" +
                       M->get_Body_Text() + "\n\n\n\n";


      ofstream outFile ( sTmpFile.c_str(), ios::out );

      if ( !outFile )   {
         error ( "File could not be opened.\n" );
      }
      else   {

         // write file
         outFile << sLetter << endl;

         // issue print sCommand
         int index = sCommand.find ( "%s" );
         if ( index == -1 )   {
            sCommand = sCommand + " " + sTmpFile;
         }
         else   {
            sCommand.replace ( index, 2, sTmpFile );  // replace "%s" with sTmpFile
         }
         system ( sCommand.c_str() );
         sCommand = "rm " + sTmpFile;
         system ( sCommand.c_str() );
      }
   }
}


void
update_message_list( Folder *the_folder )
{
  int i;
  int first_unseen = 0;
  GtkCList *message_list = GTK_CLIST (gAlthea.get_message_list());
  string flags;

  if (gAlthea.get_Verbose())
    cout << "adding " << the_folder->get_Num_Messages() << " messages..." << endl;
  gtk_clist_clear( GTK_CLIST (message_list) );
  assert( the_folder != NULL );

  if( the_folder->get_Num_Messages() > 0 )
  {
      for( i = the_folder->get_Sequence_Start(); i <= the_folder->get_Sequence_Stop(); i++)
      {
          Message *M = the_folder->get_Message( i );
          assert( M != NULL );
          char *messages[] =
              {                  
                  (char *)M->get_From_Address().c_str(),
                  (char *)M->get_Subject().c_str(),
                  (char *)M->get_Date().c_str(),
                  (char *)M->get_Flags().c_str()
              };
          
          gtk_clist_append( GTK_CLIST (message_list), messages );
          gtk_clist_set_row_data( GTK_CLIST (message_list), i-1, (gpointer) M);

          flags = M->get_Flags();
          if( flags == "" || strstr( flags.c_str(), "\\Unseen" ) != NULL
                          || strstr( flags.c_str(), "\\Recent" ) != NULL ) {
              set_row_color( GTK_CLIST (message_list), i-1, UNSEEN_COLORS );
              if( first_unseen == 0 )
                  first_unseen = i;
          } else if( strstr( flags.c_str(), "\\Deleted" ) != NULL )
              set_row_color( GTK_CLIST (message_list), i-1, DELETED_COLORS );
          else if( strstr( flags.c_str(), "\\Answered" ) != NULL )
              set_row_color( GTK_CLIST (message_list), i-1, ANSWERED_COLORS );
          else
              set_row_color( GTK_CLIST (message_list), i-1, SEEN_COLORS );
      }
      
      // Now position the clist at the first unseen message
      if( first_unseen > 0 )
        first_unseen--;
      gtk_clist_moveto( GTK_CLIST (message_list), first_unseen, 0, 0.0, 0.0 );
  }
  
  
}


void
select_server                          (GtkObject       *object,
                                        gpointer        user_data)
{
  Server *the_server = (Server *) user_data;
  gAlthea.set_Current_Server( the_server );
  if (gAlthea.get_Verbose())
    cout << "You selected server " << the_server->get_Server_Name() << endl;
  
}

void
select_folder                          (GtkObject       *object, 
                                        gpointer        user_data)
{

    int ret_val;


    Folder *the_folder = (Folder *) user_data;
    gAlthea.set_Current_Server( the_folder->get_Server_Ptr() );
    gAlthea.set_Current_Folder( the_folder );

if (gAlthea.get_Current_Server()->check_Connected() == SUCCESS)
{  


    if (gAlthea.get_Verbose())
      cout << "You selected folder " << the_folder->get_Folder_Name() << endl;
    the_folder->clear();
    ret_val = the_folder->get_Message_Headers();
    if( ret_val == SUCCESS )
        update_message_list( the_folder );
    
    else
        error( "Problem getting message headers: error was " );
}

}

void
on_print_message_activate              (GtkObject       *object,
                                        gpointer        user_data)
{
  GtkWidget *printDialog;
  printDialog = create_printDialog();
  gtk_widget_show (printDialog);
}

void
on_expunge_menu_activate               (GtkObject       *object,
                                        gpointer        user_data)
{
    if (gAlthea.get_Verbose())
      cout << "expunging" << endl;
    Folder *the_folder = gAlthea.get_Current_Folder();
    the_folder->expunge_Deleted_Mail();
}


void 
attach_file_ok                         (GtkObject       *object,
                                        gpointer        user_data)
{
  GtkWidget *attach_window = GTK_WIDGET (user_data);
  string *filename = new string( 
                      gtk_file_selection_get_filename( GTK_FILE_SELECTION (attach_window) ) );
  if (gAlthea.get_Verbose()) {
    cout << "attach file okay!" << endl;
    cout << "  filename=\"" << *filename << "\"" << endl;
  }
}


// Create the new file selection window
////////////////////////////////////////
void
attach_file                            (GtkObject       *object,
                                        gpointer        user_data)
{
  //GtkWidget *attach_window = GTK_WIDGET (user_data);
  GtkWidget *attach_window = gtk_file_selection_new( "Select File" );

  if (gAlthea.get_Verbose())
    cout << "attach file!" << endl;
  gtk_signal_connect_object( GTK_OBJECT (attach_window), "destroy",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (attach_window) );
  gtk_signal_connect_object( GTK_OBJECT (GTK_FILE_SELECTION (attach_window)->cancel_button),
                             "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (attach_window) );
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (attach_window)->ok_button),
                      "clicked",
                      GTK_SIGNAL_FUNC (attach_file_ok), 
                      attach_window );
  gtk_signal_connect_object( GTK_OBJECT (GTK_FILE_SELECTION (attach_window)->ok_button),
                             "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (attach_window) );
  gtk_widget_show( attach_window );
  
  
}

void
create_message                         (GtkObject       *object,
                                        gpointer        user_data)
{

  text_widgets *temp = (text_widgets *) user_data;
  string *to, *subject, *cc, *body;
  Server * current = gAlthea.get_Current_Server();
  assert( current != NULL );
  
  to = extract_entry( temp->to );
  subject = extract_entry( temp->subject );
  cc = extract_entry( temp->cc );
  body = extract_text( temp->body );
  Message *M = new Message( current->get_Username() + "@" + current->get_SMTP_Server_Name(), (string) *to, (string) *cc,(string) *subject );
  M->set_Body_Text( (string) *body );
  M->set_Server_Ptr( current );
  M->send();
  M->save_FCC();
  delete M;  // We don't need it any more.  This will all probably be replaced with a stand-alone function some day.
}

gboolean
on_main_window_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_main_window_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_file_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_new_message_menu_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *new_message_window=NULL;

  Server * current = gAlthea.get_Current_Server();
  if( current != NULL )
  {
      new_message_window = create_new_message_window("", "", "", "");
      gtk_widget_show( new_message_window );
  }
  else
      error( "Select server to send mail from." );
}


void 
on_select_message                      (GtkWidget *widget,
                                        gint row,
                                        gint column,
                                        GdkEventButton *event,
                                        gpointer data)
{
    string flags;
    int ret_val;
    GtkCList *message_list = GTK_CLIST (gAlthea.get_message_list());
    Message * the_message = (Message *) gtk_clist_get_row_data( message_list, row );
    assert( the_message != NULL );

    gAlthea.set_Current_Message( the_message );
    gAlthea.set_Current_Server( the_message->get_Server_Ptr() );
   
if (gAlthea.get_Current_Server()->check_Connected() == SUCCESS)
{ 
    // If we haven't gotten the message body yet, do so.  If we have set ret_val to 0
    // since we know the body retrieval was successful.

    if( the_message->have_Body_Text() == 0 )
    {
	if (gAlthea.get_Verbose())
          cout << "Message not cached... reading from server.\n";       
        ret_val = the_message->get_Body_From_Server();
    }
    else
        ret_val = SUCCESS;
    
    if( ret_val == SUCCESS )
    {    
        GtkWidget *mess_text = gAlthea.get_message_text();
        assert( mess_text != NULL );

        flags = the_message->get_Flags();
        if( flags == "" || strstr( flags.c_str(), "\\Unseen" ) != NULL
                        || strstr( flags.c_str(), "\\Recent" ) != NULL ) {
            set_row_color( GTK_CLIST (message_list), row, SEEN_COLORS );
            gtk_clist_set_text( GTK_CLIST (message_list), row, 3, flags.c_str() );
        }
  
        gtk_text_set_point( GTK_TEXT (mess_text), gtk_text_get_length( GTK_TEXT (mess_text) ) );
        gtk_text_backward_delete( GTK_TEXT (mess_text), gtk_text_get_point( GTK_TEXT (mess_text) ));
        gtk_text_insert( GTK_TEXT (mess_text), NULL, &mess_text->style->black, NULL, the_message->get_Header().c_str(), -1 );
        gtk_text_insert( GTK_TEXT (mess_text), NULL, &mess_text->style->black, NULL, the_message->get_Body_Text().c_str(), -1);
        gtk_text_set_point( GTK_TEXT (mess_text), 0 );
    }
    else
    {
        error( "Error retrieving message from server." );
        the_message->set_Have_Body( 0 );
    }
 }   
}

// Get the filename from the "Save Message" dialog box
///////////////////////////////////////////////////////
void
save_file_ok                           (GtkObject     *object, 
                                        gpointer      user_data )
{
  ofstream fout;
  GtkWidget *save_window = GTK_WIDGET (user_data);
  string *filename = new string( 
                      gtk_file_selection_get_filename( GTK_FILE_SELECTION (save_window) ) );
  string *text = new string(
                      gtk_editable_get_chars( GTK_EDITABLE (gAlthea.get_message_text()), 0, -1 ) );

  if( *text != "" ) {
    fout.open( filename->c_str() );
    if( fout == NULL ) 
      error( "Cannot write to file \"" + *filename + "\"" );
    else
      fout << *text;
    fout.close();
  }
}

// Create the save file selection box
///////////////////////////////////////
void
on_save_message_menu_activate          (GtkObject     *object,
                                        gpointer      user_data)
{
  GtkWidget *save_window = gtk_file_selection_new( "Save Message" );
  Message * M = gAlthea.get_Current_Message();

  if( M != NULL ) {
    if (gAlthea.get_Verbose())
      cout << "Save file!" << endl;
    gtk_signal_connect_object( GTK_OBJECT (save_window), "destroy",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (save_window) );
    gtk_signal_connect_object( GTK_OBJECT (GTK_FILE_SELECTION (save_window)->cancel_button),
                               "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (save_window) );
    gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (save_window)->ok_button),
                        "clicked",
                        GTK_SIGNAL_FUNC (save_file_ok), 
                        save_window );
    gtk_signal_connect_object( GTK_OBJECT (GTK_FILE_SELECTION (save_window)->ok_button),
                               "clicked",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy),
                               GTK_OBJECT (save_window) );
    gtk_widget_show( save_window );
  } else {
    error( "Select a message to save." );
  }
}


void get_mail( void ) {

  GtkTree *folder_list = GTK_TREE (gAlthea.get_folder_list());   
  GtkWidget *folder, *server;
  Server *the_server;
  Folder *F;
  int i, j, ret_val;
  for( i = 1; i <= gAlthea.get_Num_Servers(); i++ )
  {
      the_server = gAlthea.get_Server( i );
      assert( the_server != NULL );
      
      server = create_new_server( the_server, folder_list );
      if( the_server->login() == SUCCESS )
      {
          ret_val = the_server->get_Folder_List_From_Server();
          if( ret_val == SUCCESS )
          {
              for( j = 1; j <= the_server->get_Num_Folders(); j++ )
              {
                  F = the_server->get_Folder( j );
                  folder = create_folder_in_server( F, server );
              }
          }
          else
              error( "Could not get mailbox listing from server " + the_server->get_Server_Name() + "." );
      }
      
      else
          error( "Could not log in to server " + the_server->get_Server_Name() + "." );
  }
}

void
on_check_mail_menu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

if (gAlthea.is_Current_Server()) {

    Server * the_server = gAlthea.get_Current_Server();
    Folder * the_folder = the_server->get_Folder( 1 );


  if (gAlthea.get_Current_Server()->check_Connected() == SUCCESS)
  {    
      if( the_server == NULL )
          error("Select a server first.");
      else
      {
           the_server->get_New_Mail();
          //the_folder->clear();
          //int ret_val = the_folder->get_Message_Headers();
          update_message_list( the_folder);
      }
  }

} else {
error("Select a server first.");
}
}



void
on_print_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *printDialog;
  printDialog = create_printDialog();
  gtk_widget_show (printDialog);
}

/*
void
on_options_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *config_window;
  config_window = create_config_window ();
  gtk_widget_show (config_window);
}
*/

void
on_exit_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
}


void
on_edit_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_copy_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_cut_menu_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_paste_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_clear_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_select_all_menu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_search_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_search_in_message_menu_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_search_in_folders_menu_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_search_again_menu_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_advanced_search_menu_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_message_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_reply_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    GtkCList *message_list = GTK_CLIST (gAlthea.get_message_list());
    GtkWidget *new_message_window=NULL;
    Message * M = gAlthea.get_Current_Message();
    
    if( M != NULL )
    {
string from=M->get_From_Address();


if (strstr(from.c_str(),"\r")!=NULL)
	from = from.substr(0,from.find_first_of('\r'));
// THE ABOVE IS JUST A WORK ARROUND! FIX THE BUG!

string newflags;
        new_message_window = create_new_message_window(from, "Re: " + M->get_Subject(), "", (string)"\n\n\n" + (string) gtk_editable_get_chars( GTK_EDITABLE (gAlthea.get_message_text()), 0, -1 ));
        gtk_widget_show( new_message_window );
	IMAPSetFlagByUID(gAlthea.get_Current_Server()->get_Socket(),M->get_UID(), "\\Answered", newflags);
  	if (gAlthea.get_Verbose())
	  cout << "The message's flags are now: " << newflags << endl;

        int row = gtk_clist_find_row_from_data( message_list, (gpointer) M );
        gtk_clist_set_text( GTK_CLIST (message_list), row, 3, newflags.c_str() );
        set_row_color( GTK_CLIST (message_list), row, ANSWERED_COLORS );

    }
    else
        error( "Select a message to reply to." );
    
}


void
on_forward_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    GtkWidget *new_message_window=NULL;
    Message * M = gAlthea.get_Current_Message();
    if( M != NULL )
    {
        new_message_window =
create_new_message_window("", "Fwd: " + M->get_Subject(), "", (string)"\n\n\n" + (string) gtk_editable_get_chars( GTK_EDITABLE (gAlthea.get_message_text()), 0, -1 ));
        gtk_widget_show( new_message_window );
    }
    else
        error( "Select a message to forward." );

}


void
on_delete_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
if (gAlthea.is_Current_Message()) {


    Message * M = gAlthea.get_Current_Message();
    GtkCList *message_list = GTK_CLIST (gAlthea.get_message_list());
    string flags;
    int row;

    if (gAlthea.get_Current_Server()->check_Connected() == SUCCESS)
    {
        if( M != NULL ) {
            M->Delete();
            row = gtk_clist_find_row_from_data( message_list, (gpointer) M );
            if( row != -1 ) {
              flags = M->get_Flags();
              gtk_clist_set_text( GTK_CLIST (message_list), row, 3, flags.c_str() );
              set_row_color( GTK_CLIST (message_list), row, DELETED_COLORS );
            }
        } else
            error( "Select a message to delete." );
    }
} else 
    error( "Select a message to delete." );
}


void
on_undelete_menu_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    int row;
    string flags;
    GtkCList *message_list = GTK_CLIST (gAlthea.get_message_list());

    if (gAlthea.is_Current_Message()) {

        Message * M = gAlthea.get_Current_Message();
        if (gAlthea.get_Current_Server()->check_Connected() == SUCCESS)
        {
            if( M != NULL ) {
                M->Undelete();
                row = gtk_clist_find_row_from_data( message_list, (gpointer) M );
                if( row != -1 ) {
                    flags = M->get_Flags();
                    gtk_clist_set_text( GTK_CLIST (message_list), row, 3, flags.c_str() );
                    set_row_color( GTK_CLIST (message_list), row, SEEN_COLORS );
                }
            } else
                error( "Select a message to undelete." );
        } else
            error( "Select a message to undelete." );
    }
}


void
on_move_to_folder_menu_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_address_book_menu_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    error( "This feature not yet implemented." );
}


void
on_view_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_add_an_address_menu_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_import_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_export_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_help_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_index_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_contents_menu_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
         GtkWidget *helpDialog;
         helpDialog = create_helpDialog ();
         gtk_widget_show (helpDialog);

}


void
on_about_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *about_window = create_about_window();
  gtk_widget_show( about_window );
}

