//
//  callbacks.h  --  gtk functions to make callbacks
//  -- created  5/23/00 updated 5/23/00
//////////////////////////////////////////////

#ifndef CALLBACKS_H
#define CALLBACKS_H

#include <fstream.h>
#include "Folder.h"
#include <gtk/gtk.h>
#include <assert.h>
#include <string.h>

#include "main_window.h"
#include "new_message_window.h"
#include "about_window.h"
#include "printDialog.h"
#include "support.h"
#include "Althea.h"
#include "errors.h"
#include "helpDialog.h"
#include "imap.h"

#define DELETED_COLORS 255, 0, 0
#define ANSWERED_COLORS 0, 255, 0
#define UNSEEN_COLORS 55, 55, 255
#define SEEN_COLORS 0, 0, 0

void
on_password_window_okay                 (GtkObject       *object, 
                                        gpointer        user_data);


void
on_printButton_clicked                 (GtkButton       *button,
                                        gpointer         user_data);

void 
get_mail                               ( void );

void
update_message_list( Folder *the_folder );

void
select_server                          (GtkObject       *object, 
                                        gpointer        user_data);

void
select_folder                          (GtkObject       *object,
                                        gpointer        user_data);

void
on_print_message_activate              (GtkObject       *object,
                                        gpointer        user_data);

void
on_expunge_menu_activate               (GtkObject       *object,
                                        gpointer        user_data);

void attach_file( GtkObject *object, gpointer user_data );

void create_message( GtkObject *object, gpointer user_data );

gboolean
on_main_window_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_main_window_destroy                 (GtkObject       *object,
                                        gpointer         user_data);

void
on_file_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_new_message_menu_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_save_message_menu_activate          (GtkObject     *object,
                                        gpointer      user_data);

void
on_check_mail_menu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_print_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_options_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_exit_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_edit_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_copy_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_cut_menu_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_paste_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_clear_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_select_all_menu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_search_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_search_in_message_menu_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_search_in_folders_menu_activate     (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_search_again_menu_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_advanced_search_menu_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_message_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_reply_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_forward_menu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_delete_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_undelete_menu_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_move_to_folder_menu_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_address_book_menu_activate          (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_view_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_add_an_address_menu_activate        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_import_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_export_menu_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_help_menu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_index_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_contents_menu_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_about_menu_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_select_message                      (GtkWidget *widget,
                                        gint row,
                                        gint column,
                                        GdkEventButton *event,
                                        gpointer data);

#endif
