//
//  load_config.h -- functions to load the configuration file
//  -- created 4/20/00  updated 5/9/00
////////////////////////////////////////////////////////////

#ifndef LOAD_CONFIG_H
#define LOAD_CONFIG_H

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include "support.h"
#include "Althea.h"
#include "Server.h"
#include "Configuration.h"

#define LOCAL_CONFIG_FILE ".althearc"
#define RC_CONFIG_FILE "/etc/althearc"

extern Althea gAlthea;

enum config_command 
{ 
  SERVER, EXPERT, CACHE, NOCOMMAND, FILTER 
};

//  The master function that loads the configuration file into memory
int load_Althea();

// Other functions that will be used to load things into the data structure
void load_Server (const string & name, const string &smtp, const string &imap, const string & port, const string & username, const string & password, const string & folder_root, string & fccfolder );
void load_Expert_Mode (int expert);
void load_Cache (int cache);

//  Utility functions
config_command convert_upper_to_command(const string & upper_string);

#endif
