//
//  main_window.c  --  the basic window of Althea
//  -- created 5/23/00  updated 5/23/00
///////////////////////////////////////////

#include "main_window.h"

extern Althea gAlthea;

GtkWidget*
create_main_window (void)
{
  GtkWidget *main_window;
  GtkWidget *vbox1;
  GtkWidget *main_menu;
  GtkWidget *file_menu;
  GtkWidget *file_menu_menu;
  GtkAccelGroup *file_menu_menu_accels;
  GtkWidget *new_message_menu;
  GtkWidget *save_message_menu;
  GtkWidget *separator2;
  GtkWidget *check_mail_menu;
  GtkWidget *print_menu;
  //GtkWidget *options_menu;
  GtkWidget *separator3;
  GtkWidget *exit_menu;
  //GtkWidget *edit_menu;
  //GtkWidget *edit_menu_menu;
  //GtkAccelGroup *edit_menu_menu_accels;
  //GtkWidget *copy_menu;
  //GtkWidget *cut_menu;
  //GtkWidget *paste_menu;
  //GtkWidget *separator4;
  //GtkWidget *clear_menu;
  //GtkWidget *select_all_menu;
  //GtkWidget *search_menu;
  //GtkWidget *search_menu_menu;
  //GtkAccelGroup *search_menu_menu_accels;
  //GtkWidget *search_in_message_menu;
  //GtkWidget *search_in_folders_menu;
  //GtkWidget *search_again_menu;
  //GtkWidget *separator5;
  //GtkWidget *advanced_search_menu;
  GtkWidget *message_menu;
  GtkWidget *message_menu_menu;
  GtkAccelGroup *message_menu_menu_accels;
  GtkWidget *reply_menu;
  GtkWidget *forward_menu;
  GtkWidget *delete_menu;
  GtkWidget *undelete_menu;
  GtkWidget *expunge_menu;
  //GtkWidget *separator6;
  //GtkWidget *move_to_folder_menu;
  //GtkWidget *address_book_menu;
  //GtkWidget *address_book_menu_menu;
  //GtkAccelGroup *address_book_menu_menu_accels;
  //GtkWidget *view_menu;
  //GtkWidget *add_an_address_menu;
  //GtkWidget *separator7;
  //GtkWidget *import_menu;
  //GtkWidget *export_menu;
  GtkWidget *help_menu;
  GtkWidget *help_menu_menu;
  GtkAccelGroup *help_menu_menu_accels;
  //GtkWidget *index_menu;
  GtkWidget *contents_menu;
  GtkWidget *separator8;
  GtkWidget *about_menu;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *new_message;
  GtkWidget *save_message;
  GtkWidget *print_message;
  GtkWidget *reply_to_message;
  //GtkWidget *address_book;
  GtkWidget *check_mail;
  GtkWidget *delete_mail;
  GtkWidget *forward_message;
  GtkWidget *hbox1;
  GtkWidget *hpaned1;
  GtkWidget *scrolledwindow3;
  GtkWidget *viewport1;
  GtkWidget *folder_list;
  GtkWidget *vpaned1;
  GtkWidget *scrolledwindow4;
  GtkWidget *message_list;
  GtkWidget *from_label;
  GtkWidget *subject_label;
  GtkWidget *date_label;
  GtkWidget *status_label;
  GtkWidget *scrolledwindow5;
  GtkWidget *message_text;

  main_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_widget_set_usize (main_window, 700, 550);
  gtk_window_set_title (GTK_WINDOW (main_window), "Althea v0.3");
  gtk_window_set_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (main_window), vbox1);
  gtk_widget_set_usize (vbox1, 600, 450);

  main_menu = gtk_menu_bar_new ();
  gtk_widget_ref (main_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "main_menu", main_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_menu);
  gtk_box_pack_start (GTK_BOX (vbox1), main_menu, FALSE, FALSE, 0);

  file_menu = gtk_menu_item_new_with_label ("File");
  gtk_widget_ref (file_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file_menu", file_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), file_menu);

  file_menu_menu = gtk_menu_new ();
  gtk_widget_ref (file_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file_menu_menu", file_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (file_menu), file_menu_menu);
  file_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (file_menu_menu));

  new_message_menu = gtk_menu_item_new_with_label ("New Message");
  gtk_widget_ref (new_message_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new_message_menu", new_message_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_message_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), new_message_menu);

  save_message_menu = gtk_menu_item_new_with_label ("Save Message");
  gtk_widget_ref (save_message_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_message_menu", save_message_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_message_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), save_message_menu);

  separator2 = gtk_menu_item_new ();
  gtk_widget_ref (separator2);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator2", separator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator2);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), separator2);
  gtk_widget_set_sensitive (separator2, FALSE);

  check_mail_menu = gtk_menu_item_new_with_label ("Check Mail");
  gtk_widget_ref (check_mail_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "check_mail_menu", check_mail_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (check_mail_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), check_mail_menu);

  print_menu = gtk_menu_item_new_with_label ("Print");
  gtk_widget_ref (print_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "print_menu", print_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), print_menu);

  /*
  options_menu = gtk_menu_item_new_with_label ("Options");
  gtk_widget_ref (options_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "options_menu", options_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (options_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), options_menu);
  */

  separator3 = gtk_menu_item_new ();
  gtk_widget_ref (separator3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator3", separator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator3);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), separator3);
  gtk_widget_set_sensitive (separator3, FALSE);

  exit_menu = gtk_menu_item_new_with_label ("Exit");
  gtk_widget_ref (exit_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "exit_menu", exit_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit_menu);
  gtk_container_add (GTK_CONTAINER (file_menu_menu), exit_menu);

  /****** THIS IS THE EDIT MENU *******
  edit_menu = gtk_menu_item_new_with_label ("Edit");
  gtk_widget_ref (edit_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit_menu", edit_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (edit_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), edit_menu);

  edit_menu_menu = gtk_menu_new ();
  gtk_widget_ref (edit_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit_menu_menu", edit_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (edit_menu), edit_menu_menu);
  edit_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (edit_menu_menu));

  copy_menu = gtk_menu_item_new_with_label ("Copy");
  gtk_widget_ref (copy_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "copy_menu", copy_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copy_menu);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), copy_menu);

  cut_menu = gtk_menu_item_new_with_label ("Cut");
  gtk_widget_ref (cut_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "cut_menu", cut_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cut_menu);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), cut_menu);

  paste_menu = gtk_menu_item_new_with_label ("Paste");
  gtk_widget_ref (paste_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "paste_menu", paste_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (paste_menu);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), paste_menu);

  separator4 = gtk_menu_item_new ();
  gtk_widget_ref (separator4);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator4", separator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator4);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), separator4);
  gtk_widget_set_sensitive (separator4, FALSE);

  clear_menu = gtk_menu_item_new_with_label ("Clear");
  gtk_widget_ref (clear_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "clear_menu", clear_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clear_menu);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), clear_menu);

  select_all_menu = gtk_menu_item_new_with_label ("Select All");
  gtk_widget_ref (select_all_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "select_all_menu", select_all_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (select_all_menu);
  gtk_container_add (GTK_CONTAINER (edit_menu_menu), select_all_menu);
  ******* END OF THE EDIT MENU *********/

  /****** THIS IS THE SEARCH MENU *********
  search_menu = gtk_menu_item_new_with_label ("Search");
  gtk_widget_ref (search_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "search_menu", search_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), search_menu);

  search_menu_menu = gtk_menu_new ();
  gtk_widget_ref (search_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "search_menu_menu", search_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (search_menu), search_menu_menu);
  search_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (search_menu_menu));

  search_in_message_menu = gtk_menu_item_new_with_label ("Search in Message");
  gtk_widget_ref (search_in_message_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "search_in_message_menu", search_in_message_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_in_message_menu);
  gtk_container_add (GTK_CONTAINER (search_menu_menu), search_in_message_menu);

  search_in_folders_menu = gtk_menu_item_new_with_label ("Search in Folders");
  gtk_widget_ref (search_in_folders_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "search_in_folders_menu", search_in_folders_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_in_folders_menu);
  gtk_container_add (GTK_CONTAINER (search_menu_menu), search_in_folders_menu);

  search_again_menu = gtk_menu_item_new_with_label ("Search Again");
  gtk_widget_ref (search_again_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "search_again_menu", search_again_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (search_again_menu);
  gtk_container_add (GTK_CONTAINER (search_menu_menu), search_again_menu);

  separator5 = gtk_menu_item_new ();
  gtk_widget_ref (separator5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator5", separator5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator5);
  gtk_container_add (GTK_CONTAINER (search_menu_menu), separator5);
  gtk_widget_set_sensitive (separator5, FALSE);

  advanced_search_menu = gtk_menu_item_new_with_label ("Advanced Search");
  gtk_widget_ref (advanced_search_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "advanced_search_menu", advanced_search_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (advanced_search_menu);
  gtk_container_add (GTK_CONTAINER (search_menu_menu), advanced_search_menu);
  ******* END OF THE SEARCH MENU *******/

  message_menu = gtk_menu_item_new_with_label ("Message");
  gtk_widget_ref (message_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_menu", message_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), message_menu);

  message_menu_menu = gtk_menu_new ();
  gtk_widget_ref (message_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_menu_menu", message_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (message_menu), message_menu_menu);
  message_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (message_menu_menu));

  reply_menu = gtk_menu_item_new_with_label ("Reply");
  gtk_widget_ref (reply_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "reply_menu", reply_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), reply_menu);

  forward_menu = gtk_menu_item_new_with_label ("Forward");
  gtk_widget_ref (forward_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "forward_menu", forward_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (forward_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), forward_menu);

  delete_menu = gtk_menu_item_new_with_label ("Delete");
  gtk_widget_ref (delete_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete_menu", delete_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), delete_menu);

  undelete_menu = gtk_menu_item_new_with_label ("Undelete");
  gtk_widget_ref (undelete_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "undelete_menu", undelete_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (undelete_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), undelete_menu);

  expunge_menu = gtk_menu_item_new_with_label ("Expunge");
  gtk_widget_ref (expunge_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "expunge_menu", expunge_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (expunge_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), expunge_menu);
  
  /*
  separator6 = gtk_menu_item_new ();
  gtk_widget_ref (separator6);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator6", separator6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator6);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), separator6);
  gtk_widget_set_sensitive (separator6, FALSE);

  move_to_folder_menu = gtk_menu_item_new_with_label ("Move to Folder");
  gtk_widget_ref (move_to_folder_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "move_to_folder_menu", move_to_folder_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (move_to_folder_menu);
  gtk_container_add (GTK_CONTAINER (message_menu_menu), move_to_folder_menu);
  */

  /******* BEGIN ADDRESS BOOK MENU ********
  address_book_menu = gtk_menu_item_new_with_label ("Address Book");
  gtk_widget_ref (address_book_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "address_book_menu", address_book_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_book_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), address_book_menu);

  address_book_menu_menu = gtk_menu_new ();
  gtk_widget_ref (address_book_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "address_book_menu_menu", address_book_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (address_book_menu), address_book_menu_menu);
  address_book_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (address_book_menu_menu));

  view_menu = gtk_menu_item_new_with_label ("View");
  gtk_widget_ref (view_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "view_menu", view_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (view_menu);
  gtk_container_add (GTK_CONTAINER (address_book_menu_menu), view_menu);

  add_an_address_menu = gtk_menu_item_new_with_label ("Add an Address");
  gtk_widget_ref (add_an_address_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "add_an_address_menu", add_an_address_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_an_address_menu);
  gtk_container_add (GTK_CONTAINER (address_book_menu_menu), add_an_address_menu);

  separator7 = gtk_menu_item_new ();
  gtk_widget_ref (separator7);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator7", separator7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator7);
  gtk_container_add (GTK_CONTAINER (address_book_menu_menu), separator7);
  gtk_widget_set_sensitive (separator7, FALSE);

  import_menu = gtk_menu_item_new_with_label ("Import");
  gtk_widget_ref (import_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "import_menu", import_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (import_menu);
  gtk_container_add (GTK_CONTAINER (address_book_menu_menu), import_menu);

  export_menu = gtk_menu_item_new_with_label ("Export");
  gtk_widget_ref (export_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "export_menu", export_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (export_menu);
  gtk_container_add (GTK_CONTAINER (address_book_menu_menu), export_menu);
  ******* END ADDRESS BOOK MENU *******/

  help_menu = gtk_menu_item_new_with_label ("Help");
  gtk_widget_ref (help_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help_menu", help_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (help_menu);
  gtk_container_add (GTK_CONTAINER (main_menu), help_menu);

  help_menu_menu = gtk_menu_new ();
  gtk_widget_ref (help_menu_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help_menu_menu", help_menu_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (help_menu), help_menu_menu);
  help_menu_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (help_menu_menu));

  /*
  index_menu = gtk_menu_item_new_with_label ("Index");
  gtk_widget_ref (index_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "index_menu", index_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (index_menu);
  gtk_container_add (GTK_CONTAINER (help_menu_menu), index_menu);
  */

  contents_menu = gtk_menu_item_new_with_label ("Contents");
  gtk_widget_ref (contents_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "contents_menu", contents_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (contents_menu);
  gtk_container_add (GTK_CONTAINER (help_menu_menu), contents_menu);

  separator8 = gtk_menu_item_new ();
  gtk_widget_ref (separator8);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator8", separator8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (separator8);
  gtk_container_add (GTK_CONTAINER (help_menu_menu), separator8);
  gtk_widget_set_sensitive (separator8, FALSE);

  about_menu = gtk_menu_item_new_with_label ("About");
  gtk_widget_ref (about_menu);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about_menu", about_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_menu);
  gtk_container_add (GTK_CONTAINER (help_menu_menu), about_menu);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "toolbar", toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar);
  gtk_box_pack_start (GTK_BOX (vbox1), toolbar, FALSE, FALSE, 0);

  tmp_toolbar_icon = create_pixmap (main_window, "new.xpm");
  new_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Compose",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (new_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "new_message", new_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_message);

  tmp_toolbar_icon = create_pixmap (main_window, "save.xpm");
  save_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Save",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (save_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_message", save_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_message);

  tmp_toolbar_icon = create_pixmap (main_window, "print.xpm");
  print_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Print",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (print_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "print_message", print_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (print_message);

  tmp_toolbar_icon = create_pixmap (main_window, "reply.xpm");
  reply_to_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Reply",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (reply_to_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "reply_to_message", reply_to_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reply_to_message);

  tmp_toolbar_icon = create_pixmap (main_window, "forward.xpm");
  forward_message = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Forward",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (forward_message);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "forward message", forward_message,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (forward_message);

  tmp_toolbar_icon = create_pixmap (main_window, "check.xpm");
  check_mail = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Check Mail",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (check_mail);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "check_mail", check_mail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (check_mail);

  tmp_toolbar_icon = create_pixmap (main_window, "delete.xpm");
  delete_mail = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Delete Mail",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (delete_mail);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "delete_mail", delete_mail,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (delete_mail);

  hbox1 = gtk_hbox_new (FALSE, 6);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 4);

  hpaned1 = gtk_hpaned_new ();
  gtk_widget_ref (hpaned1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hpaned1", hpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hpaned1);
  gtk_box_pack_start (GTK_BOX (hbox1), hpaned1, TRUE, TRUE, 0);
  gtk_paned_set_handle_size (GTK_PANED (hpaned1), 15);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_usize( scrolledwindow3, 150, 550 );
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (hpaned1), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), viewport1);

  folder_list = gtk_tree_new ();
  gtk_widget_ref (folder_list);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "folder_list", folder_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (folder_list);
  gtk_container_add (GTK_CONTAINER (viewport1), folder_list);
  // Add it to gAlthea
  gAlthea.set_folder_list( folder_list );

  vpaned1 = gtk_vpaned_new ();
  gtk_widget_ref (vpaned1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vpaned1", vpaned1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vpaned1);
  gtk_container_add (GTK_CONTAINER (hpaned1), vpaned1);
  gtk_paned_set_handle_size (GTK_PANED (vpaned1), 15);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_usize( scrolledwindow4, 750, 150 );
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_container_add (GTK_CONTAINER (vpaned1), scrolledwindow4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  message_list = gtk_clist_new (4);
  gtk_widget_ref (message_list);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_list", message_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  // Set the selection mode so that only one thing may be selected at a time
  gtk_clist_set_selection_mode( GTK_CLIST (message_list), GTK_SELECTION_SINGLE );
  // Add the message_list to gAlthea
  gAlthea.set_message_list( message_list );
  gtk_widget_show (message_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), message_list);
  gtk_clist_set_column_width (GTK_CLIST (message_list), 0, 100);
  gtk_clist_set_column_width (GTK_CLIST (message_list), 1, 250);
  gtk_clist_set_column_width (GTK_CLIST (message_list), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (message_list), 3, 40);
  gtk_clist_column_titles_show (GTK_CLIST (message_list));

  from_label = gtk_label_new ("From");
  gtk_widget_ref (from_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "from_label", from_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (from_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_list), 0, from_label);

  subject_label = gtk_label_new ("Subject");
  gtk_widget_ref (subject_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "subject_label", subject_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subject_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_list), 1, subject_label);

  date_label = gtk_label_new ("Date");
  gtk_widget_ref (date_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "date_label", date_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (date_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_list), 2, date_label);

  status_label = gtk_label_new ("Status");
  gtk_widget_ref (status_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "status_label", status_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (status_label);
  gtk_clist_set_column_widget (GTK_CLIST (message_list), 3, status_label);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_container_add (GTK_CONTAINER (vpaned1), scrolledwindow5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  message_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (message_text);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "message_text", message_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_text_set_word_wrap( GTK_TEXT (message_text), TRUE );
  // Add message_text to gAlthea
  gAlthea.set_message_text( message_text );
  gtk_widget_show (message_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), message_text);

  gtk_signal_connect (GTK_OBJECT (expunge_menu), "activate",
                      GTK_SIGNAL_FUNC (on_expunge_menu_activate),
                      NULL);
  /*
  gtk_signal_connect (GTK_OBJECT (address_book), "clicked",
                      GTK_SIGNAL_FUNC (on_address_book_menu_activate),
                      NULL);
  */
  gtk_signal_connect (GTK_OBJECT (print_message), "clicked",
                      GTK_SIGNAL_FUNC (on_print_message_activate),
                      folder_list );
  gtk_signal_connect (GTK_OBJECT (reply_to_message), "clicked",
		      GTK_SIGNAL_FUNC (on_reply_menu_activate),
		      NULL);
  gtk_signal_connect (GTK_OBJECT (delete_mail), "clicked",
                      GTK_SIGNAL_FUNC (on_delete_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (new_message), "clicked",
                      GTK_SIGNAL_FUNC (on_new_message_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_main_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window), "destroy",
                      GTK_SIGNAL_FUNC (on_main_window_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (file_menu), "activate",
                      GTK_SIGNAL_FUNC (on_file_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (new_message_menu), "activate",
                      GTK_SIGNAL_FUNC (on_new_message_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (save_message_menu), "activate",
                      GTK_SIGNAL_FUNC (on_save_message_menu_activate),
                      NULL );
  gtk_signal_connect (GTK_OBJECT (save_message), "clicked",
                      GTK_SIGNAL_FUNC (on_save_message_menu_activate),
                      NULL );
  gtk_signal_connect (GTK_OBJECT (message_list), "select_row",
                      GTK_SIGNAL_FUNC (on_select_message),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (check_mail), "clicked",
                      GTK_SIGNAL_FUNC (on_check_mail_menu_activate),
                      message_list);
  gtk_signal_connect (GTK_OBJECT (check_mail_menu), "activate",
                      GTK_SIGNAL_FUNC (on_check_mail_menu_activate),
                      message_list);
  gtk_signal_connect (GTK_OBJECT (print_menu), "activate",
                      GTK_SIGNAL_FUNC (on_print_menu_activate),
                      NULL);
  /*
  gtk_signal_connect (GTK_OBJECT (options_menu), "activate",
                      GTK_SIGNAL_FUNC (on_options_menu_activate),
                      NULL);
  */
  gtk_signal_connect (GTK_OBJECT (exit_menu), "activate",
                      GTK_SIGNAL_FUNC (on_exit_menu_activate),
                      NULL);
  /****** BEGIN EDIT AND SEARCH MENU CALLBACKS *********
  gtk_signal_connect (GTK_OBJECT (edit_menu), "activate",
                      GTK_SIGNAL_FUNC (on_edit_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (copy_menu), "activate",
                      GTK_SIGNAL_FUNC (on_copy_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cut_menu), "activate",
                      GTK_SIGNAL_FUNC (on_cut_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (paste_menu), "activate",
                      GTK_SIGNAL_FUNC (on_paste_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clear_menu), "activate",
                      GTK_SIGNAL_FUNC (on_clear_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (select_all_menu), "activate",
                      GTK_SIGNAL_FUNC (on_select_all_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (search_menu), "activate",
                      GTK_SIGNAL_FUNC (on_search_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (search_in_message_menu), "activate",
                      GTK_SIGNAL_FUNC (on_search_in_message_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (search_in_folders_menu), "activate",
                      GTK_SIGNAL_FUNC (on_search_in_folders_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (search_again_menu), "activate",
                      GTK_SIGNAL_FUNC (on_search_again_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (advanced_search_menu), "activate",
                      GTK_SIGNAL_FUNC (on_advanced_search_menu_activate),
                      NULL);
  ***** END EDIT AND SEARCH MENU CALLBACKS *******/
  gtk_signal_connect (GTK_OBJECT (message_menu), "activate",
                      GTK_SIGNAL_FUNC (on_message_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (reply_menu), "activate",
                      GTK_SIGNAL_FUNC (on_reply_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (forward_menu), "activate",
                      GTK_SIGNAL_FUNC (on_forward_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (forward_message), "clicked",
                      GTK_SIGNAL_FUNC (on_forward_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (delete_menu), "activate",
                      GTK_SIGNAL_FUNC (on_delete_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (undelete_menu), "activate",
                      GTK_SIGNAL_FUNC (on_undelete_menu_activate),
                      NULL);
  /****** ADDRESS BOOK PLUS EXTRAS ********
  gtk_signal_connect (GTK_OBJECT (move_to_folder_menu), "activate",
                      GTK_SIGNAL_FUNC (on_move_to_folder_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (address_book_menu), "activate",
                      GTK_SIGNAL_FUNC (on_address_book_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (view_menu), "activate",
                      GTK_SIGNAL_FUNC (on_view_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (add_an_address_menu), "activate",
                      GTK_SIGNAL_FUNC (on_add_an_address_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (import_menu), "activate",
                      GTK_SIGNAL_FUNC (on_import_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (export_menu), "activate",
                      GTK_SIGNAL_FUNC (on_export_menu_activate),
                      NULL);
  ******* END ADDRESS BOOK PLUS EXTRAS ********/
  gtk_signal_connect (GTK_OBJECT (help_menu), "activate",
                      GTK_SIGNAL_FUNC (on_help_menu_activate),
                      NULL);
  /*
  gtk_signal_connect (GTK_OBJECT (index_menu), "activate",
                      GTK_SIGNAL_FUNC (on_index_menu_activate),
                      NULL);
  */
  gtk_signal_connect (GTK_OBJECT (contents_menu), "activate",
                      GTK_SIGNAL_FUNC (on_contents_menu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (about_menu), "activate",
                      GTK_SIGNAL_FUNC (on_about_menu_activate),
                      NULL);

  // Add main_window to gAlthea
  gAlthea.set_main_window( main_window );

  return main_window;
}

