//
//  new_message_window.c  --  The compose window for new messages
//  --  created 5/23/00  updated 5/23/00
////////////////////////////////////////////////

#include "new_message_window.h"

GtkWidget*
create_new_message_window (const string& to, const string& subject, const string& cc, const string& body)
{
  GtkWidget *new_message_window;
  GtkWidget *vbox1;
  GtkWidget *new_message_toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *send_button;
  GtkWidget *attach_button;
  GtkWidget *close_button;
  GtkWidget *hbox1;
  GtkWidget *to_label;
  GtkWidget *to_text;
  GtkWidget *hbox2;
  GtkWidget *subject_label;
  GtkWidget *subject_text;
  GtkWidget *hbox3;
  GtkWidget *cc_label;
  GtkWidget *cc_text;
  GtkWidget *scrolledwindow1;
  GtkWidget *compose_text;

  new_message_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (new_message_window, 500, 400);
  gtk_object_set_data (GTK_OBJECT (new_message_window), "new_message_window", new_message_window);
  gtk_container_set_border_width (GTK_CONTAINER (new_message_window), 2);
  gtk_window_set_title (GTK_WINDOW (new_message_window), "New Message");
  gtk_window_set_default_size (GTK_WINDOW (new_message_window), 300, 250);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (new_message_window), vbox1);

  new_message_toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (new_message_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "new_message_toolbar", new_message_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (new_message_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox1), new_message_toolbar, FALSE, FALSE, 2);
  gtk_container_set_border_width (GTK_CONTAINER (new_message_toolbar), 2);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (new_message_toolbar), 3);

  tmp_toolbar_icon = create_pixmap (new_message_window, "send.xpm");
  send_button = gtk_toolbar_append_element (GTK_TOOLBAR (new_message_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Send",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (send_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "send_button", send_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (send_button);
  gtk_widget_set_usize (send_button, 50, -2);

  tmp_toolbar_icon = create_pixmap (new_message_window, "attach.xpm");
  attach_button = gtk_toolbar_append_element (GTK_TOOLBAR (new_message_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Attach",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (attach_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "attach_button", attach_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (attach_button);
  gtk_widget_set_usize (attach_button, 50, -2);

  tmp_toolbar_icon = create_pixmap (new_message_window, "close.xpm");
  close_button = gtk_toolbar_append_element (GTK_TOOLBAR (new_message_toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                "Close",
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);
  gtk_widget_set_usize (close_button, 50, -2);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 0);
  gtk_widget_set_usize (hbox1, -2, 20);

  to_label = gtk_label_new ("To:");
  gtk_widget_ref (to_label);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "to_label", to_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (to_label);
  gtk_box_pack_start (GTK_BOX (hbox1), to_label, FALSE, FALSE, 2);
  gtk_widget_set_usize (to_label, 50, -2);
  gtk_label_set_justify (GTK_LABEL (to_label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (to_label), 0.9, 0.5);

  to_text = gtk_entry_new ();
  gtk_widget_ref (to_text);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "to_text", to_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text( GTK_ENTRY (to_text), (char *)to.c_str() );
  gtk_widget_show (to_text);
  gtk_box_pack_start (GTK_BOX (hbox1), to_text, TRUE, TRUE, 0);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 0);

  subject_label = gtk_label_new ("Subject:");
  gtk_widget_ref (subject_label);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "subject_label", subject_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (subject_label);
  gtk_box_pack_start (GTK_BOX (hbox2), subject_label, FALSE, FALSE, 2);
  gtk_widget_set_usize (subject_label, 50, -2);
  gtk_label_set_justify (GTK_LABEL (subject_label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (subject_label), 0.67, 0.5);

  subject_text = gtk_entry_new ();
  gtk_widget_ref (subject_text);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "subject_text", subject_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text( GTK_ENTRY (subject_text), (char *)subject.c_str() );
  gtk_widget_show (subject_text);
  gtk_box_pack_start (GTK_BOX (hbox2), subject_text, TRUE, TRUE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, TRUE, 0);

  cc_label = gtk_label_new ("Cc:");
  gtk_widget_ref (cc_label);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "cc_label", cc_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cc_label);
  gtk_box_pack_start (GTK_BOX (hbox3), cc_label, FALSE, FALSE, 2);
  gtk_widget_set_usize (cc_label, 50, -2);
  gtk_label_set_justify (GTK_LABEL (cc_label), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (cc_label), 0.78, 0.5);

  cc_text = gtk_entry_new ();
  gtk_widget_ref (cc_text);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "cc_text", cc_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text( GTK_ENTRY( cc_text), (char *)cc.c_str() );
  gtk_widget_show (cc_text);
  gtk_box_pack_start (GTK_BOX (hbox3), cc_text, TRUE, TRUE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  compose_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (compose_text);
  gtk_object_set_data_full (GTK_OBJECT (new_message_window), "compose_text", compose_text,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_text_set_editable (GTK_TEXT (compose_text), TRUE);
  gtk_text_set_word_wrap( GTK_TEXT (compose_text), TRUE );
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), compose_text);
  gtk_text_insert( GTK_TEXT (compose_text), NULL, &compose_text->style->black, NULL, (char*)body.c_str(), -1);
  gtk_widget_show (compose_text);

  // The close button should destroy this window
  gtk_signal_connect_object( GTK_OBJECT (close_button), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy), 
                             GTK_OBJECT (new_message_window) );

  // The send button sends the data to another function
  text_widgets *temp = new text_widgets;
  temp->to = GTK_ENTRY (to_text);
  temp->subject = GTK_ENTRY (subject_text);
  temp->cc = GTK_ENTRY (cc_text);
  temp->body = GTK_TEXT (compose_text);
  gtk_signal_connect( GTK_OBJECT (send_button), "clicked",
                      GTK_SIGNAL_FUNC (create_message), temp );
  gtk_signal_connect_object( GTK_OBJECT (send_button), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (new_message_window) );

  // The attach button opens a file dialog box
  gtk_signal_connect( GTK_OBJECT (attach_button), "clicked",
                      GTK_SIGNAL_FUNC (attach_file), NULL );

  gtk_widget_grab_focus( to_text );
  return new_message_window;
}

