//
//  printDialog.c  --  created a print dialog box
//  -- created 5/23/00  updated 5/23/00
////////////////////////////////////////////

#include "printDialog.h"

GtkWidget*
create_printDialog (void)
{
  GtkWidget *printDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  GtkWidget *Question;
  GtkWidget *entry1;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *printButton;
  GtkWidget *cancelButton;

  printDialog = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (printDialog), "printDialog", printDialog);
  gtk_window_set_title (GTK_WINDOW (printDialog), "Print Dialog");
  gtk_window_set_policy (GTK_WINDOW (printDialog), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (printDialog)->vbox;
  gtk_object_set_data (GTK_OBJECT (printDialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, TRUE, TRUE, 0);

  Question = gtk_label_new ("print command:  ");
  gtk_widget_ref (Question);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "Question", Question,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (Question);
  gtk_box_pack_start (GTK_BOX (hbox1), Question, FALSE, FALSE, 0);

  entry1 = gtk_entry_new ();
  gtk_widget_ref (entry1);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "entry1", entry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (hbox1), entry1, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry1), "lpr %s");

  dialog_action_area1 = GTK_DIALOG (printDialog)->action_area;
  gtk_object_set_data (GTK_OBJECT (printDialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  printButton = gtk_button_new_with_label ("Print");
  gtk_widget_ref (printButton);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "printButton", printButton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (printButton);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), printButton);
  GTK_WIDGET_SET_FLAGS (printButton, GTK_CAN_DEFAULT);

  cancelButton = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (cancelButton);
  gtk_object_set_data_full (GTK_OBJECT (printDialog), "cancelButton", cancelButton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cancelButton);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), cancelButton);
  GTK_WIDGET_SET_FLAGS (cancelButton, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (printButton), "clicked",
                      GTK_SIGNAL_FUNC (on_printButton_clicked),
                      GTK_OBJECT (entry1));
  gtk_signal_connect_object( GTK_OBJECT (printButton), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (printDialog) );
  // The close button should destroy this window
  gtk_signal_connect_object( GTK_OBJECT (cancelButton), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
                             GTK_OBJECT (printDialog) );


  gtk_widget_grab_focus (printButton);
  gtk_widget_grab_default (printButton);
  return printDialog;
}

