//
//  smtp.cpp  --  functions to send mail using smtp
//  -- created 5/23/00 updated 5/23/00
//////////////////////////////////////////////////

#include 	"smtp.h"

extern Althea gAlthea;

// send dat mail

int SMTPSend(const string &host, int port, const string &to, 
	const string &cc, const string &bcc, const string &from, 
	const string &message, string &errcode)
{

int	sock;
string	buffer;

	/* connect to port 25 on host */
        sock = MakeConnection( host.c_str(), port );

	errcode = readTilEOL(sock);
	if (strncmp(errcode.c_str(),"220",3)!=0) 
	{
		return SMTP_HOST_NOT_READY;
	}
	
	/* send helo line, probably should actually say domain at some point */	
	string helomess="helo MyHost.com\r\n";
        write(sock, helomess.c_str() , strlen(helomess.c_str()));
	if (gAlthea.get_Verbose()==2)
          cout << "C: " << helomess << endl;
	/* send from line */	
	errcode = readTilEOL(sock);
	if (strncmp(errcode.c_str(),"250",3)!=0) 
	{
		return SMTP_HOST_NO_HELO;
	}
        write(sock, "mail from: <", 12);
        write(sock, from.c_str(), strlen(from.c_str()));
        write(sock, ">\r\n", 3);
	if (gAlthea.get_Verbose()==2)
          cout << "C: mail from: <" << from << ">" << endl;

	errcode = readTilEOL(sock);
	if (strncmp(errcode.c_str(),"250",3)!=0) 
	{
		return SMTP_FROM_ERR;
	}
	

     	/* send to: line */
        write(sock, "rcpt to: <", 10);
        write(sock, to.c_str(), strlen(to.c_str()));
        write(sock, ">\r\n", 3);
	if (gAlthea.get_Verbose()==2)
          cout << "C: rcpt to: <" << to << ">" << endl;
	errcode = readTilEOL(sock);
	if (strncmp(errcode.c_str(),"250",3)!=0) 
	{
		return SMTP_TO_ERR;
	}


	if (cc!="")
	{

     	  /* send cc: line */
          write(sock, "rcpt to: <", 10);
          write(sock, cc.c_str(), strlen(cc.c_str()));
          write(sock, ">\r\n", 3);
	  if (gAlthea.get_Verbose()==2)
          	cout << "C: rcpt cc: <" << cc << ">" << endl;
	  errcode = readTilEOL(sock);
	  if (strncmp(errcode.c_str(),"250",3)!=0) 
	  {
		return SMTP_TO_ERR;
	  }
	}

        /* send message */
        write(sock, "data\r\n", 6);
	if (gAlthea.get_Verbose()==2)
          cout << "C: " << "data" << endl << "[DATA HERE]" << endl;
        write(sock, message.c_str(), strlen(message.c_str()));
	/* quit */
	errcode = readTilEOL(sock);
	if (strncmp(errcode.c_str(),"354",3)!=0) 
	{
		return SMTP_DATA_ERR;
	}


        write(sock, "\r\n", 2);
        write(sock, "quit\r\n",6);
	if (gAlthea.get_Verbose()==2)
          cout << "C: " << "quit" << endl;
	return SUCCESS;
}
