//
//  support.h  --  support functions for gtk parts of program
//  -- created 5/23/00  updated 5/23/00
///////////////////////////////////////////////

#ifndef SUPPORT_H
#define SUPPORT_H

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include "callbacks.h"
#include <iostream.h>
#include <string>
#include <gtk/gtk.h>

#include "Althea.h"

string *extract_text( GtkText *the_widget );
string *extract_entry( GtkEntry *the_widget );
void error( string error_string );
GtkWidget *create_error_window( string error_string );
GtkWidget *create_new_server( Server *the_server, GtkTree *folder_list );
GtkWidget *create_folder_in_server( Folder *the_folder, GtkWidget *server );
GdkColor *new_color( int r, int g, int b );
void set_row_color( GtkCList *list, int row, int r, int g, int b );
void create_password_window( Server *the_server );

struct text_widgets {
  GtkEntry *to;
  GtkEntry *subject;
  GtkEntry *cc;
  GtkText *body;
};

struct password_widgets {
  GtkWidget *password_text;
  Server *the_server;
};

/*
 * Public Functions.
 */

/*
 * This function returns a widget in a component created by Glade.
 * Call it with the toplevel widget in the component (i.e. a window/dialog),
 * or alternatively any widget in the component, and the name of the widget
 * you want returned.
 */
GtkWidget*  lookup_widget              (GtkWidget       *widget,
                                        const gchar     *widget_name);

/* get_widget() is deprecated. Use lookup_widget instead. */
#define get_widget lookup_widget

/* Use this function to set the directory containing installed pixmaps. */
void        add_pixmap_directory       (const gchar     *directory);


/*
 * Private Functions.
 */

/* This is used to create the pixmaps in the interface. */
GtkWidget*  create_pixmap              (GtkWidget       *widget,
                                        const gchar     *filename);
#endif
